/*
 * Subverse
 * Copyright (C) 2007 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#ifndef ELEMENT_H_
#define ELEMENT_H_

#include <allegro.h>
#include <iostream>
#include <string>
#include "Config.h"
#include "Utils.h"
#include "Vision.h"

class World;
class Vision;

class Element {
private:
	// Attributes
	int posX, posY;
	World *world;
	BITMAP *image[8];
	BITMAP *myImage;
	string name;
	int type;
	int direction;
	int timer;
	int maxTime;
	int worldSecound;
	int visionRange;
	Vision* vision;
	bool walking;
	bool working;
	// Private Methods
	void loadImages(string);
	void incTimer();
	
public:
	// Public Methods
	Element(World*, string, int);
	bool isWalking();
	bool isWorking();
	bool isStep();
	void setWalking(bool);
	void setWorking(bool);
	void setX(int);
	void setY(int);
	void setMaxTime(int);
	bool move(int);
	void resetTime();
	void setVision(Vision*);
	int getMaxTime();
	int getDirection();
	int getAddX();
	int getAddY();
	int getX();
	int getY();
	int getType();
	int getTime();
	int getVisionRange();
	Vision* getVision();
	World* getWorld();
	string getName();
	void setDirection(int);
	virtual void run();
	virtual BITMAP* getImage();
    virtual ~Element();
};

#endif /* ELEMENT_H_ */
