/*
 * Subverse
 * Copyright (C) 2007 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Spider.h"
#include "World.h"
#include <stdlib.h>

Spider::Spider(World* w) :
	Element(w, "spider", SPIDER)
{
}

void Spider::run() {
	Element::run();
	int dir = getDirection();
	if (!isWalking()) {
		if (!move(dir)) {
			switch (dir) {
				case UP    : dir = LEFT; break;
				case LEFT  : dir = DOWN; break;
				case DOWN  : dir = RIGHT; break;
				case RIGHT : dir = UP; break;
			}
			setDirection(dir);
		}
	}
}

Spider::~Spider() {
}
